
Ruby - Bug #17735

`Hash#transform_keys!` drops non evaluated keys

03/20/2021 06:33 AM - kachick (Kenichi Kamiya)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.0.0p0 (2020-12-25 revision

95aff21468) [x86_64-darwin20]

Backport: 2.6: REQUIRED, 2.7: REQUIRED, 3.0:

DONE

Description

hash = {a: 1, b: 2, c: 3}

hash.transform_values!(){ raise } rescue

p hash #=> {:a=>1, :b=>2, :c=>3}

 
hash = {a: 1, b: 2, c: 3}

hash.transform_keys!(){ raise } rescue

p hash #=> {}

 Is this an intentional behavior?

I expected behavior like transform_values! in transform_keys! (Keeping non evaluated key-value pairs when exiting the block).

PR: https://github.com/ruby/ruby/pull/4294

Associated revisions

Revision 31e0382723bfb35cffe3ca485dd0577668cafa07 - 03/28/2021 12:14 AM - kachick (Kenichi Kamiya)

Keep non evaluated keys in Hash#transform_keys! [Bug #17735]

Revision 31e0382723bfb35cffe3ca485dd0577668cafa07 - 03/28/2021 12:14 AM - kachick (Kenichi Kamiya)

Keep non evaluated keys in Hash#transform_keys! [Bug #17735]

Revision 31e03827 - 03/28/2021 12:14 AM - kachick (Kenichi Kamiya)

Keep non evaluated keys in Hash#transform_keys! [Bug #17735]

Revision 5e5fb72f99701dc27c66ab148471893f14e6d6f0 - 03/28/2021 12:42 AM - nobu (Nobuyoshi Nakada)

Clear an intermediate hash [Bug #17735]

Revision 5e5fb72f99701dc27c66ab148471893f14e6d6f0 - 03/28/2021 12:42 AM - nobu (Nobuyoshi Nakada)

Clear an intermediate hash [Bug #17735]

Revision 5e5fb72f - 03/28/2021 12:42 AM - nobu (Nobuyoshi Nakada)

Clear an intermediate hash [Bug #17735]

Revision 522d4cd32f7727886f4fcbc28ed29c08d361ee20 - 03/28/2021 05:09 AM - kachick (Kenichi Kamiya)

Force recycle intermediate collection in Hash#transform_keys! [Bug #17735]

Force recycle intermediate hash

Force recycle intermediate array too

https://github.com/ruby/ruby/pull/4329#issuecomment-808840718

Revision 522d4cd32f7727886f4fcbc28ed29c08d361ee20 - 03/28/2021 05:09 AM - kachick (Kenichi Kamiya)

Force recycle intermediate collection in Hash#transform_keys! [Bug #17735]

Force recycle intermediate hash
Force recycle intermediate array too

https://github.com/ruby/ruby/pull/4329#issuecomment-808840718

Revision 522d4cd3 - 03/28/2021 05:09 AM - kachick (Kenichi Kamiya)

Force recycle intermediate collection in Hash#transform_keys! [Bug #17735]

Force recycle intermediate hash

Force recycle intermediate array too

https://github.com/ruby/ruby/pull/4329#issuecomment-808840718

Revision 84d9a9afc0b49d095541acb9832f8b12fb506e19 - 04/15/2021 01:25 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s)

31e0382723bfb35cffe3ca485dd0577668cafa07,5e5fb72f99701dc27c66ab148471893f14e6d6f0,fb6ebe55d91187d9635e0183d47dbf38e95b1141,522

d4cd32f7727886f4fcbc28ed29c08d361ee20: [Backport #17735]

    Keep non evaluated keys in `Hash#transform_keys!` [Bug #17735]

    ---

     hash.c                                     |  6 +++++-

     spec/ruby/core/hash/transform_keys_spec.rb | 12 +++++++++++-

     test/ruby/test_hash.rb                     |  8 ++++++++

     3 files changed, 24 insertions(+), 2 deletions(-)

    Clear an intermediate hash [Bug #17735]

    ---

     hash.c | 1 +

     1 file changed, 1 insertion(+)

    Hide an intermediate array

    ---

     hash.c | 6 ++++--

     1 file changed, 4 insertions(+), 2 deletions(-)

    Force recycle intermediate collection in Hash#transform_keys! [Bug

     #17735]

    * Force recycle intermediate hash

    * Force recycle intermediate array too

    https://github.com/ruby/ruby/pull/4329#issuecomment-808840718

    ---

     hash.c | 2 ++

     1 file changed, 2 insertions(+)

Revision 84d9a9afc0b49d095541acb9832f8b12fb506e19 - 04/15/2021 01:25 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s)

31e0382723bfb35cffe3ca485dd0577668cafa07,5e5fb72f99701dc27c66ab148471893f14e6d6f0,fb6ebe55d91187d9635e0183d47dbf38e95b1141,522

d4cd32f7727886f4fcbc28ed29c08d361ee20: [Backport #17735]

    Keep non evaluated keys in `Hash#transform_keys!` [Bug #17735]

    ---

     hash.c                                     |  6 +++++-

     spec/ruby/core/hash/transform_keys_spec.rb | 12 +++++++++++-

     test/ruby/test_hash.rb                     |  8 ++++++++

     3 files changed, 24 insertions(+), 2 deletions(-)

    Clear an intermediate hash [Bug #17735]

    ---

     hash.c | 1 +

     1 file changed, 1 insertion(+)

    Hide an intermediate array
    ---

     hash.c | 6 ++++--

     1 file changed, 4 insertions(+), 2 deletions(-)

    Force recycle intermediate collection in Hash#transform_keys! [Bug

     #17735]

    * Force recycle intermediate hash

    * Force recycle intermediate array too

    https://github.com/ruby/ruby/pull/4329#issuecomment-808840718

    ---

     hash.c | 2 ++

     1 file changed, 2 insertions(+)

Revision 84d9a9af - 04/15/2021 01:25 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s)

31e0382723bfb35cffe3ca485dd0577668cafa07,5e5fb72f99701dc27c66ab148471893f14e6d6f0,fb6ebe55d91187d9635e0183d47dbf38e95b1141,522

d4cd32f7727886f4fcbc28ed29c08d361ee20: [Backport #17735]

    Keep non evaluated keys in `Hash#transform_keys!` [Bug #17735]

    ---

     hash.c                                     |  6 +++++-

     spec/ruby/core/hash/transform_keys_spec.rb | 12 +++++++++++-

     test/ruby/test_hash.rb                     |  8 ++++++++

     3 files changed, 24 insertions(+), 2 deletions(-)

    Clear an intermediate hash [Bug #17735]

    ---

     hash.c | 1 +

     1 file changed, 1 insertion(+)

    Hide an intermediate array

    ---

     hash.c | 6 ++++--

     1 file changed, 4 insertions(+), 2 deletions(-)

    Force recycle intermediate collection in Hash#transform_keys! [Bug

     #17735]

    * Force recycle intermediate hash

    * Force recycle intermediate array too

    https://github.com/ruby/ruby/pull/4329#issuecomment-808840718

    ---

     hash.c | 2 ++

     1 file changed, 2 insertions(+)

Revision bb84c75001f1bf13b4b2a12db8f4420e76a3ea03 - 09/14/2021 05:53 AM - kachick (Kenichi Kamiya)

Revert "Force recycle intermediate collection in Hash#transform_keys! [Bug #17735]"

This reverts commit 522d4cd32f7727886f4fcbc28ed29c08d361ee20.

Revision bb84c75001f1bf13b4b2a12db8f4420e76a3ea03 - 09/14/2021 05:53 AM - kachick (Kenichi Kamiya)

Revert "Force recycle intermediate collection in Hash#transform_keys! [Bug #17735]"

This reverts commit 522d4cd32f7727886f4fcbc28ed29c08d361ee20.

Revision bb84c750 - 09/14/2021 05:53 AM - kachick (Kenichi Kamiya)

Revert "Force recycle intermediate collection in Hash#transform_keys! [Bug #17735]"

This reverts commit 522d4cd32f7727886f4fcbc28ed29c08d361ee20.

Revision 98ac62de5cb03efec0fb32684c61c0d4df692e5a - 09/18/2021 07:23 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) bb84c75001f1bf13b4b2a12db8f4420e76a3ea03: [Backport #17735]

    Revert "Force recycle intermediate collection in Hash#transform_keys!

     [Bug #17735]"

    This reverts commit 522d4cd32f7727886f4fcbc28ed29c08d361ee20.

    ---

     hash.c | 1 -

     1 file changed, 1 deletion(-)

Revision 98ac62de5cb03efec0fb32684c61c0d4df692e5a - 09/18/2021 07:23 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) bb84c75001f1bf13b4b2a12db8f4420e76a3ea03: [Backport #17735]

    Revert "Force recycle intermediate collection in Hash#transform_keys!

     [Bug #17735]"

    This reverts commit 522d4cd32f7727886f4fcbc28ed29c08d361ee20.

    ---

     hash.c | 1 -

     1 file changed, 1 deletion(-)

Revision 98ac62de - 09/18/2021 07:23 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) bb84c75001f1bf13b4b2a12db8f4420e76a3ea03: [Backport #17735]

    Revert "Force recycle intermediate collection in Hash#transform_keys!

     [Bug #17735]"

    This reverts commit 522d4cd32f7727886f4fcbc28ed29c08d361ee20.

    ---

     hash.c | 1 -

     1 file changed, 1 deletion(-)

History

#1 - 03/20/2021 08:52 AM - nobu (Nobuyoshi Nakada)

These are just a bug, not a spec.

  ruby_version_is ""..."2.5.1" do

    it "partially modifies the contents if we broke from the block" do

      @hash.transform_keys! do |v|

        break if v == :c

        v.succ

      end

      @hash.should == { c: 1, d: 4 }

    end

  end

  ruby_version_is "2.5.1" do

    it "returns the processed keys if we broke from the block" do

      @hash.transform_keys! do |v|

        break if v == :c

        v.succ

      end

      @hash.should == { b: 1, c: 2 }

    end

  end

#2 - 03/28/2021 12:15 AM - kachick (Kenichi Kamiya)

- Status changed from Open to Closed

Applied in changeset git|31e0382723bfb35cffe3ca485dd0577668cafa07.

Keep non evaluated keys in Hash#transform_keys! [Bug #17735]

#3 - 03/28/2021 09:55 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7: UNKNOWN, 3.0: UNKNOWN to 2.5: UNKNOWN, 2.6: REQUIRED, 2.7: REQUIRED,

3.0: REQUIRED

I have confirmed that the issue is reproducible on 2.6/2.7 too.
#4 - 04/15/2021 01:29 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.5: UNKNOWN, 2.6: REQUIRED, 2.7: REQUIRED, 3.0: REQUIRED to 2.5: UNKNOWN, 2.6: REQUIRED, 2.7: REQUIRED,

3.0: DONE

ruby_3_0 84d9a9afc0b49d095541acb9832f8b12fb506e19 merged revision(s)

31e0382723bfb35cffe3ca485dd0577668cafa07,5e5fb72f99701dc27c66ab148471893f14e6d6f0,fb6ebe55d91187d9635e0183d47dbf38e95b1141,522

d4cd32f7727886f4fcbc28ed29c08d361ee20.

#5 - 09/14/2021 10:24 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.5: UNKNOWN, 2.6: REQUIRED, 2.7: REQUIRED, 3.0: DONE to 2.6: REQUIRED, 2.7: REQUIRED, 3.0: REQUIRED

522d4cd32f7727886f4fcbc28ed29c08d361ee20 was reverted at bb84c75001f1bf13b4b2a12db8f4420e76a3ea03. Should I backport it into ruby_3_0?

#6 - 09/18/2021 07:51 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.6: REQUIRED, 2.7: REQUIRED, 3.0: REQUIRED to 2.6: REQUIRED, 2.7: REQUIRED, 3.0: DONE

Additionally backported bb84c75001f1bf13b4b2a12db8f4420e76a3ea03 into ruby_3_0 at 98ac62de5cb03efec0fb32684c61c0d4df692e5a.
